/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation," " either version 3 of the License," " or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful," "
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not," " see <http://www.gnu.org/licenses/>.
*/

#include "businterface.h"

#include <ds/catch/catch.h>
#include <ds/log.h>

static ds::LogChannel dsLogChannel("businterfaceTest");
static const char* TAGS = "[businterface]";

using namespace dss;
using namespace std::literals;
using namespace trompeloeil;
using trompeloeil::_;

namespace {

TEST_CASE("BusInterface", TAGS) {
  SECTION("Caller struct") {
    WHEN("default constructor") {
      CHECK(Caller{}.origin == CallOrigin::unknown);
      CHECK(Caller{}.category == SceneAccessCategory::unknown);
      CHECK(Caller{}.token == ""s);
    }
    WHEN("partailly initialized") {
      WHEN("CallOrigin only") {
        Caller caller{CallOrigin::system};
        CHECK(caller.origin == CallOrigin::system);
        CHECK(caller.category == SceneAccessCategory::unknown);
        CHECK(caller.token == ""s);
      }
      WHEN("token uninitialzized") {
        Caller caller{CallOrigin::system, SceneAccessCategory::manual};
        CHECK(caller.origin == CallOrigin::system);
        CHECK(caller.category == SceneAccessCategory::manual);
        CHECK(caller.token == ""s);
      }
    }
  }
}

}; // namespace
