/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "clock.h"

namespace ds {

///
/// Mocker for Clock.
///
/// When ClockMocker intance is created, clock advances manually by calls to advance().
///
/// - only one ClockMocker instance is allowed at a time.
/// - creating / destroying mocker and using Clock is not thread safe.
///     ClockMocker shall be activated before the clock is used.
///     ClockMocker shall be deactivate after clock is used.
///
class ClockMocker {
public:
  ClockMocker();
  ~ClockMocker();

  void advance(Clock::duration);
};

} // namespace ds
