/*
    Copyright (c) 2016 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <memory>

#include "dssfwd.h"
#include "event.h"

namespace dss {

class ScriptEnvironment;
class ScriptContextWrapper;

class EventInterpreterPluginJavascript : public EventInterpreterPlugin {
private:
  std::shared_ptr<ScriptEnvironment> m_pEnvironment;
  std::shared_ptr<InternalEventRelayTarget> m_pRelayTarget;
  static const std::string kCleanupScriptsEventName;
  PropertyNodePtr m_pScriptRootNode;

  std::vector<std::shared_ptr<ScriptContextWrapper> > m_WrappedContexts;

private:
  void initializeEnvironment();
  void setupCleanupEvent();
  void cleanupTerminatedScripts(Event& _event, const EventSubscription& _subscription);

public:
  EventInterpreterPluginJavascript(EventInterpreter* _pInterpreter);
  ~EventInterpreterPluginJavascript();

  virtual void handleEvent(Event& _event, const EventSubscription& _subscription);
}; // EventInterpreterPluginJavascript

} // namespace dss
