/*
    Copyright (c) 2009,2010,2011 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <digitalSTROM/dsuid.h>
#include <ds485types.h>

#include <boost/serialization/strong_typedef.hpp>

#include "metering/metering-fwd.h"

namespace dss::metering {

struct ValueRange; // getSeries reply type

using ArchiveId = std::pair<Dsuid, Category>;
BOOST_STRONG_TYPEDEF(std::string, OpenMeteringSystemId); // SerialNumer

struct TimeSeriesConfig;
class ArchivesConnection;
class ArchivesStorage;
class ArchivesSanity;

class ControllerDirection;
class OpenMeteringSystem;

struct ArchiveValue; // tuned to dsmeter archive format

namespace readings {
struct OpenMeteringSystem;
}

namespace archives {
class OpenMeteringSystemArchive;
class ControllerArchives;
} // namespace archives

} // namespace dss::metering
