/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>

#include "archives-storage.h"

namespace dss::metering {

struct ArchivesStorageMock : public trompeloeil::mock_interface<ArchivesStorage> {
  IMPLEMENT_CONST_MOCK0(storageLocation);
  IMPLEMENT_MOCK1(setMeteringStorageLocation);
  MAKE_CONST_MOCK0(searchOmsArchives, std::vector<OpenMeteringSystemId>());
  MAKE_CONST_MOCK1(filepath, std::string(const ArchiveId& archiveId));
  MAKE_CONST_MOCK1(filepath, std::string(const OpenMeteringSystemId& id));
  MAKE_CONST_MOCK1(hasArchive, bool(const OpenMeteringSystemId& id));
  MAKE_CONST_MOCK1(hasArchive, bool(const ArchiveId& archiveId));
  IMPLEMENT_CONST_MOCK0(searchArchives);
  IMPLEMENT_CONST_MOCK0(searchRrdFiles);
};

} // namespace dss::metering
