/*
    Copyright (c) 2022 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include "open-metering-system.h"

#include <trompeloeil.hpp>

#include "metering/metering.h"
#include "metering/readings/open-metering-system.h"

namespace dss::metering::archives {

struct OpenMeteringSystemArchiveMock final : public trompeloeil::mock_interface<OpenMeteringSystemArchive> {
  IMPLEMENT_MOCK2(create);
  IMPLEMENT_MOCK2(addValue);
  IMPLEMENT_CONST_MOCK1(lastValue);
  IMPLEMENT_CONST_MOCK7(getSeries);
  IMPLEMENT_CONST_MOCK1(validate);
  IMPLEMENT_MOCK1(migrate);
  IMPLEMENT_CONST_MOCK1(flush);
  IMPLEMENT_CONST_MOCK1(lastTimestamp);
};

} // namespace dss::metering::archives
