/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <trompeloeil.hpp>

#include "metering/controller-direction.h"

namespace dss::metering {

class ControllerDirectionMock final : public trompeloeil::mock_interface<ControllerDirection> {
  IMPLEMENT_CONST_MOCK0(meterings);
  IMPLEMENT_CONST_MOCK6(getSeries);
  IMPLEMENT_CONST_MOCK3(get15MinuteAverage);
  IMPLEMENT_CONST_MOCK1(getLastEnergy);
  IMPLEMENT_CONST_MOCK1(getEnergy);
  IMPLEMENT_CONST_MOCK3(getLastReading);
  IMPLEMENT_CONST_MOCK2(getLastReadingApartment);
  IMPLEMENT_CONST_MOCK1(getInstantPower);
  IMPLEMENT_CONST_MOCK0(getApartmentPower);
  IMPLEMENT_MOCK2(addEnergy);
  IMPLEMENT_MOCK1(pollTimestamp);
  IMPLEMENT_CONST_MOCK1(needsFlushing);
  IMPLEMENT_CONST_MOCK1(validateAndConvertArchive);
};

} // namespace dss::metering
