/*
    Copyright (c) 2018  digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/
#pragma once

#include <model/dsmeter.h>

#include <trompeloeil.hpp>

#include "apartment.h"
#include "model-features.h"

namespace dss {

class ModelFeaturesMock final : public trompeloeil::mock_interface<ModelFeatures> {
  IMPLEMENT_MOCK3(setFeatures);
  IMPLEMENT_MOCK1(getFeatures);
  IMPLEMENT_CONST_MOCK0(getAvailableFeatures);
};

class ApartmentMock final : public trompeloeil::mock_interface<Apartment> {
  using trompeloeil::mock_interface<Apartment>::mock_interface;

  IMPLEMENT_MOCK1(setMetering);
  IMPLEMENT_MOCK0(getMetering);
  IMPLEMENT_CONST_MOCK0(id);

  ModelFeatures* getModelFeatures() override { return &modelFeatures; }

  ModelFeaturesMock modelFeatures;
};

} // namespace dss
