#pragma once

#include <ds/json.h>
#include <ds/system.h>

//#include "config.hpp"

namespace dss::p1 {

struct SerialPortConfig {
  int baudRate{115200};
  size_t readBufferCapacity{65536};
  std::string serialDevice{"/dev/ttyUSB0"};
};

struct ConfigFile {
  SerialPortConfig serialPortConfig{};
};

ConfigFile loadConfigFile(ds::System&);

} // namespace dss::p1

DS_JSON_DECLARE_STRUCT((dss::p1), SerialPortConfig, (baudRate)(readBufferCapacity)(serialDevice));
DS_JSON_DECLARE_STRUCT((dss::p1), ConfigFile, (serialPortConfig));
