#pragma once

#include <ds/json.h>

#include <string>
#include <vector>

#include "metering/readings/open-metering-system.h"

namespace dss::p1 {

using MeterReading = dss::metering::readings::OpenMeteringSystem;

ds::DateTime convertOmsTimepoint(const std::string& omsTimestamp);
void parseLine(const std::string& line, dss::p1::MeterReading& currentReading);

class MeterParser {
public:
  std::optional<MeterReading> parseFrame(const std::vector<char>& buffer);
  bool vaildateCrc(const std::vector<char>& buffer, std::string crc);
  int getCrcErrorCount() { return m_crcErrCount; }
  void resetCrcCount() { m_crcErrCount = 0; }

private:
  int m_crcErrCount = 0;
};

} // namespace dss::p1
