#pragma once

#include <ds/log.h>

#include <boost/asio.hpp>
#include <boost/asio/local/stream_protocol.hpp>
#include <iostream>
#include <string>

using boost::asio::io_context;
using boost::asio::local::stream_protocol;

namespace dss::p1 {

class SocketClient : public std::enable_shared_from_this<SocketClient> {
public:
  SocketClient(io_context& io, std::string path)
      : m_endpoint(stream_protocol::endpoint(path)), m_socket(stream_protocol::socket(io)) {}

  void send(std::string&& message);

  void doConnect();

  void disconnect();

  void doWrite();

private:
  stream_protocol::endpoint m_endpoint;
  stream_protocol::socket m_socket;
  std::string m_buffer;
};

} // namespace dss::p1
