/*
    Copyright (c) 2018 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#include "reregister-devices.h"
#include "model/dsmeter.h"

#include <ds/log.h>

static ds::LogChannel dsLogChannel("reregisterDevices");

namespace dss {

void reregisterDevices(const DSMeter& controller, DsaHttpClient& dsa, BackendVdcs& backendVdcs) {
  if (controller.getBusMemberType() == BusMember_backendVdc) {
    backendVdcs.reregisterDevices(controller.getDSID());
  } else {
    dsa.request(dss::HttpRequest{.url = ds::str("/dsa/json/dsm/restartRegistration?dsuid=", controller.getDSID())});
  }
}
} // namespace dss
