/*
    Copyright (c) 2010,2011,2022 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <digitalSTROM/dsm-api-v2/dsm-api.h>
#include <digitalSTROM/dsuid.h>

#include "dssfwd.h"
#include "taskprocessor.h"

namespace dss {

class BinaryInputScanner : public Task {
public:
  BinaryInputScanner(Apartment* _papartment, const std::string& _busConnection);
  virtual ~BinaryInputScanner();

  virtual void run();
  virtual void setup(std::shared_ptr<DSMeter> _dsMeter, std::shared_ptr<Device> _device);

  uint16_t getDeviceSensorValue(const dsuid_t& _dsm, dev_t _device, uint8_t _sensorIndex) const;
  uint8_t getDeviceConfig(const dsuid_t& _dsm, dev_t _device, uint8_t _configClass, uint8_t _configIndex) const;

private:
  Apartment* m_pApartment;
  std::string m_busConnection;
  DsmApiHandle_t m_dsmApiHandle;
  std::weak_ptr<DSMeter> m_dsm;
  std::weak_ptr<Device> m_device;
};

} // namespace dss
