/*
    Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include <digitalSTROM/dsuid.h>

#include "model/device.h" // DeviceOEMState_t
#include "taskprocessor.h"
#include "webservice_connection.h"

namespace dss {

class OEMWebQuery : public Task {
public:
  class OEMWebQueryCallback : public URLRequestCallback {
  public:
    OEMWebQueryCallback(dsuid_t _deviceDSUID, DeviceOEMState_t _oldState, PropertySystem& propertySystem);
    virtual void result(long code, const std::string& result);

  private:
    PropertySystem& m_propertySystem;
    dsuid_t m_deviceDSUID;
    DeviceOEMState_t m_oldOEMState;
    std::string m_configLink;
  };

  OEMWebQuery(WebserviceConnection* webserviceConnection, std::shared_ptr<Device> _device, DeviceOEMState_t _oldState,
              PropertySystem& propertySystem);
  virtual void run();

private:
  PropertySystem& m_propertySystem;
  dsuid_t m_deviceDSUID;
  std::string m_EAN;
  uint16_t m_partNumber;
  uint16_t m_serialNumber;
  bool m_queryConfigLink;
  DeviceOEMState_t m_oldOEMState;
  WebserviceConnection* m_connection;
};

} // namespace dss
