#/bin/bash

# Compiles and installs /po/{language_COUNTRY}/{resource}.mo into $1/LC_MESSAGES/{language_COUNTRY}/{resource}.mo
# Installs all /locale-json/{language-COUNTRY}/{resource}.json into $1/locale-json/{language-COUNTRY}/{resource}.mo

set -e

cd ${TOP_SRCDIR:-.}
. ./tx-env.sh

destlocaledir="$1"/locale
destlocalejsondir="$1"/locale-json
if [ -z "${destlocaledir}" ]; then
    echo "Usage: tx-install.sh datarootdir"
    exit 1
fi

for language in ${languages}; do
    if [ "${language}" == "en_pseudo" ]; then
      continue
    fi
    languageCode=`echo $language | tr '_' '-'`
    dir=po/${language}
    modir=${destlocaledir}/${language}/LC_MESSAGES
    mkdir -p ${modir}
    for resource in ${resources}; do
        mo=${modir}/${resource}.mo
        echo ${mo}
        if [ -f ${dir}/${resource}.po ]; then
            msgfmt -o ${mo} ${dir}/${resource}.po
        fi
        json=${destlocalejsondir}/${languageCode}/${resource}.json
        install -D locale-json/${languageCode}/${resource}.json ${json}
        echo ${json}
    done
done
